<?php

class ControllerAccountForgotten extends Controller
{
    private $error = array();

    public function index()
    {
        if ($this->customer->isLogged()) {
            $this->response->redirect($this->url->link('account/account'));
        }

        $this->load->language('account/forgotten');

        $this->document->setTitle($this->language->get('heading_title'));

        $this->load->model('account/customer');

        if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {


            if ($this->request->post['type'] == 'mobile') {
                $this->checksms($this->request->post['telephone']);
                $customer_info = $this->model_account_customer->getCustomerByMobile($this->request->post['telephone']);
                $this->model_account_customer->editPassword($customer_info['customer_id'],
                    $this->session->data['checkpassword']);
                $this->session->data['success'] = '重设密码链接已发送到您的手机！';
            } else {

                $customer_info = $this->model_account_customer->getCustomerByEmail($this->request->post['email']);
                $this->model_account_customer->editCode($customer_info['customer_id'], token(40));
                $this->session->data['success'] = $this->language->get('text_success');

            }


            $this->response->redirect($this->url->link('account/login'));
        }

        if (isset($this->request->post['type'])) {
            $data['register_type'] = $this->request->post['type'];
        } else {
            $data['register_type'] = 'mobile';
        }
        $data['breadcrumbs'] = array();

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_home'),
            'href' => $this->url->link('common/home')
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_account'),
            'href' => $this->url->link('account/account')
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_forgotten'),
            'href' => $this->url->link('account/forgotten')
        );

        if (isset($this->error['warning'])) {
            $data['error_warning'] = $this->error['warning'];
        } else {
            $data['error_warning'] = '';
        }

        if (isset($this->error['mobiles'])) {
            $data['error_mobiles'] = $this->error['mobiles'];
        } else {
            $data['error_mobiles'] = '';
        }

        $data['action'] = $this->url->link('account/forgotten');

        $data['back'] = $this->url->link('account/login');

        if (isset($this->request->post['email'])) {
            $data['email'] = $this->request->post['email'];
        } else {
            $data['email'] = '';
        }
        if (isset($this->error['telephone'])) {
            $data['error_telephone'] = $this->error['telephone'];
        } else {
            $data['error_telephone'] = '';
        }
        $data['column_left']    = $this->load->controller('common/column_left');
        $data['column_right']   = $this->load->controller('common/column_right');
        $data['content_top']    = $this->load->controller('common/content_top');
        $data['content_bottom'] = $this->load->controller('common/content_bottom');
        $data['footer']         = $this->load->controller('common/footer');
        $data['header']         = $this->load->controller('common/header');

        $this->response->setOutput($this->load->view('account/forgotten', $data));
    }


    protected function checksms($mobile)
    {
        $this->load->model('setting/setting');
        $user = $this->config->get('config_ihuyiuser');
        $pass = $this->config->get('config_ihuyipass');
        if (empty($user) && empty($pass)) {
            return 2;
            exit;
        }
        $code    = rand(1000, 9999);
        $content = '您的验证码是：' . $code . '。请不要把验证码泄露给其他人。';
        $url     = 'http://106.ihuyi.com/webservice/sms.php?method=Submit&account=' . $user . '&password=' . $pass . '&mobile=' . $mobile . '&content=' . $content;
        $result  = file_get_contents($url);
        $result  = $this->xml_to_array($result);
        if ($result['SubmitResult']['code'] == 2) {
            $this->session->data['checkpassword'] = $code;
            return 0;
            exit;
        } else {
            return $result['SubmitResult']['msg'];
            exit;
        }
    }

    //将 xml数据转换为数组格式。
    function xml_to_array($xml)
    {
        $reg = "/<(\w+)[^>]*>([\\x00-\\xFF]*)<\\/\\1>/";
        if (preg_match_all($reg, $xml, $matches)) {
            $count = count($matches[0]);
            for ($i = 0; $i < $count; $i++) {
                $subxml = $matches[2][$i];
                $key    = $matches[1][$i];
                if (preg_match($reg, $subxml)) {
                    $arr[$key] = $this->xml_to_array($subxml);
                } else {
                    $arr[$key] = $subxml;
                }
            }
        }
        return $arr;
    }

    protected function validate()
    {
        if ($this->request->post['type'] == 'mobile') {

            if ($this->request->post['mobiles'] != $this->session->data['mobile_code']) {
                $this->error['mobiles'] = '短信验证码错误';
            }


            if ($this->request->post['telephone'] && !$this->model_account_customer->getTotalCustomersByTelephone($this->request->post['telephone'])) {
                $this->error['warning'] = $this->language->get('error_exists_telephone');

            }

        }


        if (!isset($this->request->post['email'])) {
            $this->error['warning'] = $this->language->get('error_email');
        } elseif (!$this->model_account_customer->getTotalCustomersByEmail($this->request->post['email'])) {
            $this->error['warning'] = $this->language->get('error_email');
        }

        // Check if customer has been approved.
        $customer_info = $this->model_account_customer->getCustomerByEmail($this->request->post['email']);

        if ($customer_info && !$customer_info['status']) {
            $this->error['warning'] = $this->language->get('error_approved');
        }

        return !$this->error;
    }
}
